﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Text.RegularExpressions;
using SHDocVw;//プロジェクト [参照の追加] [COM]タブ [Microsoft Internet Controls]



namespace DkHelper
{
    public partial class Form1 : Form
    {

        private string m_contents;
        private int m_textSize;//表示サイズ
       

        public Form1()
        {
            string defaultURL = "http://jp.digikey.com/";
            InitializeComponent();
            Application.Idle += new EventHandler(OnIdle);
            m_textSize = 2;
            string[] args = Environment.GetCommandLineArgs();
            if(args.Length>=2){
                defaultURL = args[1];
            }
            webBrowser1.Navigate(defaultURL);
            //webBrowser1.Url = new Uri(defaultURL);
        }
                        
        private void webBrowser1_Navigated(object sender, WebBrowserNavigatedEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("webBrowser1_Navigated - "+webBrowser1.Url.ToString()+"\n");

            string str = webBrowser1.Url.ToString();
            str = str.Replace("+", "%2B");

            textBoxURL.Text = str;
        }


        /// <summary>
        /// アイドル時の動作
        /// </summary>
        /// <param name="s"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// ボタンの有効/無効を設定している。
        /// </remarks>
        private void OnIdle(object s, EventArgs e)
        {
            buttonGoBackBack.Enabled = webBrowser1.CanGoBack;
            buttonGoBack.Enabled = webBrowser1.CanGoBack;
            buttonGoForward.Enabled = webBrowser1.CanGoForward;
            buttonLarger.Enabled = CanLarger();
            buttonSmaller.Enabled = CanSmaller();
        }


        private void buttonGoBack_Click(object sender, EventArgs e)
        {
            webBrowser1.GoBack();

        }

        private void buttonGoBackBack_Click(object sender, EventArgs e)
        {
            webBrowser1.GoBack();
            webBrowser1.GoBack();

        }


        private void buttonGoForward_Click(object sender, EventArgs e)
        {
            webBrowser1.GoForward();
        }
 
        /// <summary>
        /// WebBrowserコントロールからHTMLドキュメントを得て、目的の値を抽出して表示、クリップボードへコピー
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// 正規表現オブジェクトのRegexを使って抽出しています。
        /// Digikeyが送ってくるデータが変わったり、他のサイト用に改造したりするときは、おもにこのメソッドを変更することになると思います。
        /// このメソッドの最後で文字列をタブで連結してクリップボードにテキスト形式でコピーしています。
        /// 不要な項目があったり、順序を変えたいときは修正してください。
        /// </remarks>
        private void buttonParse_Click(object sender, EventArgs e)
        {
            m_contents = webBrowser1.DocumentText;
            
            
            Regex reg = new Regex(
                "<tr><th.*?>Digi-Key品番</th><td.*?>(?<dkpn>.*?)</td>.*?" +
                "<tr><th>数量</th><th>単価</th><th>価格.*?</th></tr>.*?<tr>.*?" +
                "<td.*?>(?<minlot>.*?)</td>"+
                "<td.*?>(?<price>.*?)</td>",
                
                RegexOptions.IgnoreCase | RegexOptions.Singleline);

            Match m = reg.Match(m_contents);
            string strDkPn = m.Groups["dkpn"].Value;
            string strMinLot = m.Groups["minlot"].Value;
            string strPrice = m.Groups["price"].Value;


            reg = new Regex(
                "<tr><th.*?>在庫数量</th>.*?<td.*?>(?<stock>.*?)<",
                RegexOptions.IgnoreCase | RegexOptions.Singleline);

            m = reg.Match(m_contents);
            string strStock = m.Groups["stock"].Value;


            reg = new Regex(
                "<tr><th.*?>仕入先</th><td><a href=.+?>(?<mfr>.*?)</a></td></tr>",
                RegexOptions.IgnoreCase | RegexOptions.Singleline);

            m = reg.Match(m_contents);
            string strMfr = m.Groups["mfr"].Value;


            reg = new Regex(
                "<tr><th.*?>メーカー品番</th><td>(?<mfrpn>.*?)</td>",
                 RegexOptions.IgnoreCase | RegexOptions.Singleline);

            m = reg.Match(m_contents);
            string strMfrPn = m.Groups["mfrpn"].Value;



            //取得した文字列をテキストボックスに反映
            textBoxMfr.Text = strMfr;
            textBoxDkPn.Text = strDkPn;
            textBoxMfrPn.Text = strMfrPn;
            textBoxMinLot.Text = strMinLot;
            textBoxPrice.Text = strPrice;
            textBoxStock.Text = strStock;

            //クリップボードに転送する文字列の作成と、クリップボードへのコピー
            //Excelに貼り付けるときに便利なように各文字列をタブで連結しています。
            string strToCopy = strMfr + "\t" + strMfrPn + "\t" + strDkPn + "\t" + strStock + "\t" + strMinLot + "\t" + strPrice;
            Clipboard.SetDataObject(strToCopy);
        }


        /// <summary>
        /// URLテキストボックスでのキーダウンハンドラ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// Enterキーが押されたときにURLをWebBrowserコントロールに設定
        /// </remarks>
        private void textBoxURL_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 0x0d) {
                System.Diagnostics.Debug.WriteLine("textBoxURL_KeyDown()");
                webBrowser1.Navigate(textBoxURL.Text);
                //Uri url = new Uri(textBoxURL.Text);
                //webBrowser1.Url = url;
            }
        }

        /// <summary>
        /// フォームがロードされたときの動作
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <remarks>
        /// WebBrowserコントロールをパネルいっぱいにしている。
        /// フォームエディタでFillにしていると、フォームエディタでパネルの選択が面倒なので
        /// </remarks>
        private void Form1_Load(object sender, EventArgs e)
        {
            webBrowser1.Dock = DockStyle.Fill;
        }

        //private void button1_Click(object sender, EventArgs e)
        //{
        //    try {
        //        StreamReader sr = new StreamReader(@"C:\temp\dkdat\Digikey1.dat");
        //        m_contents = sr.ReadToEnd();
        //    }catch{
        //    }
        //}

        //private void button2_Click(object sender, EventArgs e)
        //{
        //    try {
        //        StreamReader sr = new StreamReader(@"C:\temp\dkdat\Digikey2.dat");
        //        m_contents = sr.ReadToEnd();
        //    }catch{
        //    }

        //}

        //private void button3_Click(object sender, EventArgs e)
        //{
        //    try {
        //        StreamReader sr = new StreamReader(@"C:\temp\dkdat\Digikey3.dat");
        //        m_contents = sr.ReadToEnd();
        //    }catch{
        //    }

        //}

        //文字サイズ変更関係のメソッド群
        private void setTextSize()
        {
                object sizein = m_textSize;
                object sizeout = Type.Missing;
                ((SHDocVw.IWebBrowser2)(webBrowser1.ActiveXInstance)).ExecWB(OLECMDID.OLECMDID_ZOOM, OLECMDEXECOPT.OLECMDEXECOPT_DONTPROMPTUSER, ref sizein, ref sizeout);
        }

        private bool CanLarger()
        {
            return (m_textSize < 4);
        }

        private bool CanSmaller()
        {
            return (m_textSize > 0);
        }

        private void buttonLarger_Click(object sender, EventArgs e)
        {
            if (m_textSize < 4) {
                m_textSize++;
                setTextSize();
            }
        }

        private void buttonSmaller_Click(object sender, EventArgs e)
        {
            if (m_textSize > 0) {
                m_textSize--;
                setTextSize();
            }
        }

        //更新ボタン
        private void buttonRefresh_Click(object sender, EventArgs e)
        {
            //Uri url = new Uri(textBoxURL.Text);
            if (webBrowser1.Url.ToString() == textBoxURL.Text) {
                webBrowser1.Refresh();
            } else {
                webBrowser1.Navigate(textBoxURL.Text);
                //webBrowser1.Url = url;
            }
        }


         
    }
}
